'use strict';

var path = require('path');
var pluginutils = require('@rollup/pluginutils');

var index = (options = {}) => {
  options = Object.assign({
    jsxCompatPath: path.join(__dirname, "../src/vue-jsx-compat.js"),
    jsxFactory: "vueJsxCompat"
  }, options);
  console.log(options.jsxCompatPath);
  const filter = pluginutils.createFilter(options.include, options.exclude);
  return {
    name: "vueJsx",
    transform(code, id) {
      if (!filter(id))
        return;
      if (id.endsWith("x")) {
        code += `
import { ${options.jsxFactory} } from '${options.jsxCompatPath}'`;
      }
      return code;
    }
  };
};

module.exports = index;
